// (C) 2001-2018 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.

package alt_mge_phy_reconfig_parameters_CFG1;

localparam ram_depth = 7;
function [26:0] get_ram_data;
  input integer index;
  automatic reg [0:6][26:0] ram_data = {
    27'h10C0704, // [26:16]-DPRIO address=0x10C; [15:8]-bit mask=0x07; [2:0]-pma_tx_buf_slew_rate_ctrl=slew_r4(3'h4);
    27'h1350F0F, // [26:16]-DPRIO address=0x135; [15:8]-bit mask=0x0F; [3:2]-cdr_pll_lf_resistor_pd=lf_pd_setting3(2'h3); [1:0]-cdr_pll_lf_resistor_pfd=lf_pfd_setting3(2'h3);
    27'h1360F08, // [26:16]-DPRIO address=0x136; [15:8]-bit mask=0x0F; [3:0]-cdr_pll_set_cdr_vco_speed_fix=56(4'h8);
    27'h1390701, // [26:16]-DPRIO address=0x139; [15:8]-bit mask=0x07; [2:0]-cdr_pll_chgpmp_current_pfd=cp_current_pfd_setting1(3'h1);
    27'h13A3F23, // [26:16]-DPRIO address=0x13A; [15:8]-bit mask=0x3F; [5:3]-cdr_pll_pd_l_counter=4(3'h4); [2:0]-cdr_pll_pfd_l_counter=2(3'h3);
    27'h13BFF19, // [26:16]-DPRIO address=0x13B; [15:8]-bit mask=0xFF; [7:0]-cdr_pll_mcnt_div=25(8'h19);
    27'h1790202  // [26:16]-DPRIO address=0x179; [15:8]-bit mask=0x02; [1:1]-pma_rx_odi_xrx_path_x119_rx_path_rstn_overrideb=use_sequencer(1'h1);
};

  begin
  get_ram_data = ram_data[index];
  end
endfunction

localparam PLL_SELECT_VALUE = 0;

localparam HSSI_ADAPT_RX_HD_HSSIADAPT_PLD_PCS_RX_CLK_OUT_HZ_VALUE = 31'd156250000;

localparam HSSI_ADAPT_TX_HD_HSSIADAPT_AIB_HSSI_TX_TRANSFER_CLK_HZ_VALUE = 31'd156250000;

localparam HSSI_ADAPT_TX_HD_HSSIADAPT_PLD_PCS_TX_CLK_OUT_HZ_VALUE = 31'd156250000;

localparam PMA_ADAPT_SEQUENCER_RX_PATH_RSTN_OVERRIDEB_VALUE = "use_sequencer";

localparam PMA_ADAPT_DATARATE_BPS_VALUE = "3125000000";

localparam CDR_PLL_CHGPMP_CURRENT_PFD_VALUE = "cp_current_pfd_setting1";
localparam CDR_PLL_CHGPMP_CURRENT_PFD_ADDR_OFST = 313;
localparam CDR_PLL_CHGPMP_CURRENT_PFD_ADDR_FIELD_OFST = 0;
localparam CDR_PLL_CHGPMP_CURRENT_PFD_ADDR_FIELD_HIGH = 2;
localparam CDR_PLL_CHGPMP_CURRENT_PFD_ADDR_FIELD_SIZE = 3;
localparam CDR_PLL_CHGPMP_CURRENT_PFD_ADDR_FIELD_BITMASK = 32'h00000007;
localparam CDR_PLL_CHGPMP_CURRENT_PFD_ADDR_FIELD_VALMASK = 32'h00000001;
localparam CDR_PLL_CHGPMP_CURRENT_PFD_ADDR_FIELD_VALUE = 3'h1;

localparam CDR_PLL_DATARATE_BPS_VALUE = "3125000000";

localparam CDR_PLL_LF_RESISTOR_PD_VALUE = "lf_pd_setting3";
localparam CDR_PLL_LF_RESISTOR_PD_ADDR_OFST = 309;
localparam CDR_PLL_LF_RESISTOR_PD_ADDR_FIELD_OFST = 2;
localparam CDR_PLL_LF_RESISTOR_PD_ADDR_FIELD_HIGH = 3;
localparam CDR_PLL_LF_RESISTOR_PD_ADDR_FIELD_SIZE = 2;
localparam CDR_PLL_LF_RESISTOR_PD_ADDR_FIELD_BITMASK = 32'h0000000C;
localparam CDR_PLL_LF_RESISTOR_PD_ADDR_FIELD_VALMASK = 32'h0000000C;
localparam CDR_PLL_LF_RESISTOR_PD_ADDR_FIELD_VALUE = 2'h3;

localparam CDR_PLL_LF_RESISTOR_PFD_VALUE = "lf_pfd_setting3";
localparam CDR_PLL_LF_RESISTOR_PFD_ADDR_OFST = 309;
localparam CDR_PLL_LF_RESISTOR_PFD_ADDR_FIELD_OFST = 0;
localparam CDR_PLL_LF_RESISTOR_PFD_ADDR_FIELD_HIGH = 1;
localparam CDR_PLL_LF_RESISTOR_PFD_ADDR_FIELD_SIZE = 2;
localparam CDR_PLL_LF_RESISTOR_PFD_ADDR_FIELD_BITMASK = 32'h00000003;
localparam CDR_PLL_LF_RESISTOR_PFD_ADDR_FIELD_VALMASK = 32'h00000003;
localparam CDR_PLL_LF_RESISTOR_PFD_ADDR_FIELD_VALUE = 2'h3;

localparam CDR_PLL_LPD_COUNTER_VALUE = 5'd4;

localparam CDR_PLL_LPFD_COUNTER_VALUE = 5'd2;

localparam CDR_PLL_MCNT_DIV_VALUE = 8'd25;
localparam CDR_PLL_MCNT_DIV_ADDR_OFST = 315;
localparam CDR_PLL_MCNT_DIV_ADDR_FIELD_OFST = 0;
localparam CDR_PLL_MCNT_DIV_ADDR_FIELD_HIGH = 7;
localparam CDR_PLL_MCNT_DIV_ADDR_FIELD_SIZE = 8;
localparam CDR_PLL_MCNT_DIV_ADDR_FIELD_BITMASK = 32'h000000FF;
localparam CDR_PLL_MCNT_DIV_ADDR_FIELD_VALMASK = 32'h00000019;
localparam CDR_PLL_MCNT_DIV_ADDR_FIELD_VALUE = 8'h19;

localparam CDR_PLL_OUT_FREQ_VALUE = "1562500000";

localparam CDR_PLL_PD_L_COUNTER_VALUE = 4;
localparam CDR_PLL_PD_L_COUNTER_ADDR_OFST = 314;
localparam CDR_PLL_PD_L_COUNTER_ADDR_FIELD_OFST = 3;
localparam CDR_PLL_PD_L_COUNTER_ADDR_FIELD_HIGH = 5;
localparam CDR_PLL_PD_L_COUNTER_ADDR_FIELD_SIZE = 3;
localparam CDR_PLL_PD_L_COUNTER_ADDR_FIELD_BITMASK = 32'h00000038;
localparam CDR_PLL_PD_L_COUNTER_ADDR_FIELD_VALMASK = 32'h00000020;
localparam CDR_PLL_PD_L_COUNTER_ADDR_FIELD_VALUE = 3'h4;

localparam CDR_PLL_PFD_L_COUNTER_VALUE = 2;
localparam CDR_PLL_PFD_L_COUNTER_ADDR_OFST = 314;
localparam CDR_PLL_PFD_L_COUNTER_ADDR_FIELD_OFST = 0;
localparam CDR_PLL_PFD_L_COUNTER_ADDR_FIELD_HIGH = 2;
localparam CDR_PLL_PFD_L_COUNTER_ADDR_FIELD_SIZE = 3;
localparam CDR_PLL_PFD_L_COUNTER_ADDR_FIELD_BITMASK = 32'h00000007;
localparam CDR_PLL_PFD_L_COUNTER_ADDR_FIELD_VALMASK = 32'h00000003;
localparam CDR_PLL_PFD_L_COUNTER_ADDR_FIELD_VALUE = 3'h3;

localparam CDR_PLL_POWERMODE_AC_RVCOTOP_VALUE = "rvcotop_ac_div4";

localparam CDR_PLL_POWERMODE_DC_RVCOTOP_VALUE = "rvcotop_dc_div4";

localparam CDR_PLL_SET_CDR_VCO_SPEED_FIX_VALUE = 8'd56;
localparam CDR_PLL_SET_CDR_VCO_SPEED_FIX_ADDR0_OFST = 306;
localparam CDR_PLL_SET_CDR_VCO_SPEED_FIX_ADDR0_FIELD_OFST = 0;
localparam CDR_PLL_SET_CDR_VCO_SPEED_FIX_ADDR0_FIELD_HIGH = 3;
localparam CDR_PLL_SET_CDR_VCO_SPEED_FIX_ADDR0_FIELD_SIZE = 4;
localparam CDR_PLL_SET_CDR_VCO_SPEED_FIX_ADDR0_FIELD_BITMASK = 32'h0000000F;
localparam CDR_PLL_SET_CDR_VCO_SPEED_FIX_ADDR0_FIELD_VALMASK = 32'h00000003;
localparam CDR_PLL_SET_CDR_VCO_SPEED_FIX_ADDR0_FIELD_VALUE = 4'h3;
localparam CDR_PLL_SET_CDR_VCO_SPEED_FIX_ADDR1_OFST = 310;
localparam CDR_PLL_SET_CDR_VCO_SPEED_FIX_ADDR1_FIELD_OFST = 0;
localparam CDR_PLL_SET_CDR_VCO_SPEED_FIX_ADDR1_FIELD_HIGH = 3;
localparam CDR_PLL_SET_CDR_VCO_SPEED_FIX_ADDR1_FIELD_SIZE = 4;
localparam CDR_PLL_SET_CDR_VCO_SPEED_FIX_ADDR1_FIELD_BITMASK = 32'h0000000F;
localparam CDR_PLL_SET_CDR_VCO_SPEED_FIX_ADDR1_FIELD_VALMASK = 32'h00000008;
localparam CDR_PLL_SET_CDR_VCO_SPEED_FIX_ADDR1_FIELD_VALUE = 4'h8;

localparam CDR_PLL_VCO_FREQ_VALUE = "6250000000";

localparam PMA_RX_BUF_DATARATE_BPS_VALUE = "3125000000";

localparam PMA_RX_BUF_PM_CR2_RX_PATH_DATARATE_BPS_VALUE = "3125000000";

localparam PMA_RX_BUF_PM_CR2_RX_PATH_PMA_RX_DIVCLK_HZ_VALUE = "312500000";

localparam PMA_RX_DESER_DATARATE_BPS_VALUE = "3125000000";

localparam PMA_RX_DFE_DATARATE_BPS_VALUE = "3125000000";

localparam PMA_RX_ODI_DATARATE_BPS_VALUE = "3125000000";

localparam PMA_RX_ODI_XRX_PATH_X119_RX_PATH_RSTN_OVERRIDEB_VALUE = "use_sequencer";
localparam PMA_RX_ODI_XRX_PATH_X119_RX_PATH_RSTN_OVERRIDEB_ADDR_OFST = 377;
localparam PMA_RX_ODI_XRX_PATH_X119_RX_PATH_RSTN_OVERRIDEB_ADDR_FIELD_OFST = 1;
localparam PMA_RX_ODI_XRX_PATH_X119_RX_PATH_RSTN_OVERRIDEB_ADDR_FIELD_HIGH = 1;
localparam PMA_RX_ODI_XRX_PATH_X119_RX_PATH_RSTN_OVERRIDEB_ADDR_FIELD_SIZE = 1;
localparam PMA_RX_ODI_XRX_PATH_X119_RX_PATH_RSTN_OVERRIDEB_ADDR_FIELD_BITMASK = 32'h00000002;
localparam PMA_RX_ODI_XRX_PATH_X119_RX_PATH_RSTN_OVERRIDEB_ADDR_FIELD_VALMASK = 32'h00000002;
localparam PMA_RX_ODI_XRX_PATH_X119_RX_PATH_RSTN_OVERRIDEB_ADDR_FIELD_VALUE = 1'h1;

localparam PMA_TX_BUF_DATARATE_BPS_VALUE = "3125000000";

localparam PMA_TX_BUF_PM_CR2_TX_PATH_DATARATE_BPS_VALUE = "3125000000";

localparam PMA_TX_BUF_PM_CR2_TX_PATH_PMA_TX_DIVCLK_HZ_VALUE = "312500000";

localparam PMA_TX_BUF_SLEW_RATE_CTRL_VALUE = "slew_r4";
localparam PMA_TX_BUF_SLEW_RATE_CTRL_ADDR_OFST = 268;
localparam PMA_TX_BUF_SLEW_RATE_CTRL_ADDR_FIELD_OFST = 0;
localparam PMA_TX_BUF_SLEW_RATE_CTRL_ADDR_FIELD_HIGH = 2;
localparam PMA_TX_BUF_SLEW_RATE_CTRL_ADDR_FIELD_SIZE = 3;
localparam PMA_TX_BUF_SLEW_RATE_CTRL_ADDR_FIELD_BITMASK = 32'h00000007;
localparam PMA_TX_BUF_SLEW_RATE_CTRL_ADDR_FIELD_VALMASK = 32'h00000004;
localparam PMA_TX_BUF_SLEW_RATE_CTRL_ADDR_FIELD_VALUE = 3'h4;

localparam PMA_TX_BUF_PM_CR2_TX_PATH_TX_PLL_CLK_HZ_VALUE = "1562500000";

localparam PMA_CGB_DATARATE_BPS_VALUE = "3125000000";

localparam PMA_CGB_INPUT_SELECT_X1_VALUE = "fpll_bot";

localparam PMA_RESET_SEQUENCER_RX_PATH_RSTN_OVERRIDEB_VALUE = "use_sequencer";

localparam HSSI_PLDADAPT_RX_HDPLDADAPT_AIB_FABRIC_RX_TRANSFER_CLK_HZ_VALUE = 31'd156250000;

localparam HSSI_PLDADAPT_RX_HDPLDADAPT_PLD_RX_CLK1_DCM_HZ_VALUE = 31'd156250000;

localparam HSSI_PLDADAPT_RX_HDPLDADAPT_PLD_RX_CLK1_ROWCLK_HZ_VALUE = 31'd156250000;

localparam HSSI_PLDADAPT_TX_HDPLDADAPT_AIB_FABRIC_PMA_AIB_TX_CLK_HZ_VALUE = 31'd156250000;

localparam HSSI_PLDADAPT_TX_HDPLDADAPT_PLD_TX_CLK1_DCM_HZ_VALUE = 31'd156250000;

localparam HSSI_PLDADAPT_TX_HDPLDADAPT_PLD_TX_CLK1_ROWCLK_HZ_VALUE = 31'd156250000;

localparam HSSI_PLDADAPT_TX_HDPLDADAPT_PLD_TX_CLK2_DCM_HZ_VALUE = 31'd156250000;

localparam HSSI_PLDADAPT_TX_HDPLDADAPT_PLD_TX_CLK2_ROWCLK_HZ_VALUE = 31'd156250000;

localparam HSSI_RX_PLD_PCS_INTERFACE_HD_PCS_CHANNEL_PMA_RX_CLK_HZ_VALUE = 30'd312500000;

localparam HSSI_TX_PLD_PCS_INTERFACE_HD_PCS_CHANNEL_PMA_TX_CLK_HZ_VALUE = 30'd312500000;

endpackage